#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "pcx.h"
#include "editskin.h"
#include "mouse.h"
#include "ranges.h"
#include "keys.h"
#include "config.h"

pcx_header pcx;

int tow(int x,int y)
{
  if (y>x) x++;
  if (y<x) x--;
  
  return x;
}

void empty_mousebuffer()
{
  while (es_checkbutton(ev.mb)==ES_LEFTBUTTON) ev=es_handler(ev); 
}

void m_button(int x, int y)
{
  int px,py;
  
  if (RANGE_PALETTE(x,y))
    {
      if (PALETTESEARCH(x,y)<256) // && PALETTESEARCH(x,y) != 0)
	{
	  s_color=PALETTESEARCH(x,y);
	  for (px=600; px<WIDTH; px++)
	    for (py=440; py<HEIGHT; py++)
	      es_pixel(px,py);
	  pinfo(EMPTYSTRING);
	  pinfo(colorhelp[s_color].name);
	} 
      empty_mousebuffer();
    } else
      
      if (RANGE_IMAGE(x,y))
	{
	  if (rounded==1)
	    {
	      for (px=x-pointer; px<x+pointer; px+=2)
		for (py=y-pointer; py<y+pointer; py+=2)
		  if (px>-1 && px<640 && py>-1 && py<401)
		    if (ROUNDSEARCHA( (px-x),(py-y) ))
		      if (BLACKSEARCH(px,py)==0)
			DATASEARCH(px,py)=s_color;
	      for (px=-pointer; px<pointer; px++)
		for (py=-pointer; py<pointer; py++)
		  if ((x/2)*2+px>-1 && (x/2)*2+px<640 && (y/2)*2+py<400 && (y/2)*2+py>-1)
		    es_pixel((x/2)*2+px, (y/2)*2+py);
	    } else
	      {
		for (px=x; px<x+pointer*2-1; px+=2)
		  for (py=y; py<y+pointer*2-1; py+=2)
		    if (px<640 && py<400)
		      if (BLACKSEARCH(px,py)==0)
			DATASEARCH(px,py)=s_color;
		for (px=0; px<pointer*2; px++)
		  for (py=0; py<pointer*2; py++)
		    if ((x/2)*2+px<640 && (y/2)*2+py<400)
		      es_pixel((x/2)*2+px,(y/2)*2+py);
	      }
	} else
	  
	  if (RANGE_SHIRTARROWR(x,y))
	    {
	      if (shirtcolor<15)
		{
		  shirtcolor++;
		  for (px=SHIRTWIDGET_PX+58; px<SHIRTWIDGET_PX+71; px++)
		    for (py=SHIRTWIDGET_PY-4; py<SHIRTWIDGET_PY+8; py++)
		      es_pixel(px,py);
		  
		  if (showrealc==1)
		    for (px=0; px<WIDTH; px++)
		      for (py=0; py<400; py++)
			es_pixel(px,py);
		  empty_mousebuffer();
		}
	    } else
	      
	      if (RANGE_SHIRTARROWL(x,y))
		{
		  if (shirtcolor>1)
		    {
		      shirtcolor--;
		      for (px=SHIRTWIDGET_PX+58; px<SHIRTWIDGET_PX+71; px++)
			for (py=SHIRTWIDGET_PY-4; py<SHIRTWIDGET_PY+8; py++)
			  es_pixel(px,py);
		      
		      if (showrealc==1)
			for (px=0; px<WIDTH; px++)
			  for (py=0; py<400; py++)
			    es_pixel(px,py);
		      empty_mousebuffer();
		    }
		} else
		  
		  if (RANGE_PANTARROWR(x,y))
		    {
		      if (pantcolor<15)
			{
			  pantcolor++;
			  for (px=PANTWIDGET_PX+58; px<PANTWIDGET_PX+71; px++)
			    for (py=PANTWIDGET_PY-5; py<PANTWIDGET_PY+8; py++)
			      es_pixel(px,py);
			  
			  if (showrealc==1)
			    for (px=0; px<WIDTH; px++)
			      for (py=0; py<400; py++)
				es_pixel(px,py);
			  empty_mousebuffer();
			}
		    } else
		      
		      if (RANGE_PANTARROWL(x,y))
			{
			  if (pantcolor>1)
			    {
			      pantcolor--;
			      for (px=PANTWIDGET_PX+58; px<PANTWIDGET_PX+71; px++)
				for (py=PANTWIDGET_PY-5; py<PANTWIDGET_PY+8; py++)
				  es_pixel(px,py);
			      
			      
			      if (showrealc==1)
				for (px=0; px<WIDTH; px++)
				  for (py=0; py<400; py++)
				    es_pixel(px,py);
			      empty_mousebuffer();
			    }
			} else
			  
			  if (RANGE_QUITB(x,y))
			    quit=1;
			  else
			    
			    if (RANGE_SAVEB(x,y))
			      {
				savebox(pcx);
				empty_mousebuffer();
			      } 
}

void m_brighten(int x, int y)
{
  int px,py;
  
  if (RANGE_IMAGE(x,y))
    {
      if (rounded==1)
	{
	  for (px=x-pointer; px<x+pointer; px+=2)
	    for (py=y-pointer; py<y+pointer; py+=2)
	      if (px>-1 && px<640 && py>-1 && py<400 &&
		  ROUNDSEARCHA( (px-x),(py-y) ) &&
		  BLACKSEARCH(px,py)==0)
		DATASEARCH(px,py)=colorhelp[DATASEARCH(px,py)].brighter;
	  for (px=-pointer; px<pointer; px++)
	    for (py=-pointer; py<pointer; py++)
	      if ((x/2)*2+px<640 && (y/2)*2+py<400 &&
		  (x/2)*2+px>-1 && (y/2)*2+py>-1)
		es_pixel((x/2)*2+px, (y/2)*2+py);
	}
      else
	{
	  for (px=x; px<x+pointer*2-1; px+=2)
	    for (py=y; py<y+pointer*2-1; py+=2)
	      if (RANGE_IMAGE(px,py) &&
		  BLACKSEARCH(px,py))
		DATASEARCH(px,py)=colorhelp[DATASEARCH(px,py)].brighter;
	  for (px=0; px<pointer*2+1; px++)
	    for (py=0; py<pointer*2+1; py++)
	      if ((x/2)*2+px<640 && (y/2)*2+py<400)
		es_pixel((x/2)*2+px,(y/2)*2+py);
	}
    }
  
}

void m_darken(int x, int y)
{
  int px,py;
  
  if (RANGE_IMAGE(x,y))
    {
      if (rounded==1)
	{
	  for (px=x-pointer; px<x+pointer; px+=2)
	    for (py=y-pointer; py<y+pointer; py+=2)
	      if (px>-1 && px<640 && py>=0 && py<401 &&
		  ROUNDSEARCHA( (px-x),(py-y) ) &&
		  BLACKSEARCH(px,py)==0)
		DATASEARCH(px,py)=colorhelp[DATASEARCH(px,py)].darker;
	  for (px=-pointer; px<pointer; px++)
	    for (py=-pointer; py<pointer; py++)
	      if ((x/2)*2+px<640 && (y/2)*2+py<400 &&
		  (x/2)*2+px>-1 && (y/2)*2+py>-1)
		es_pixel((x/2)*2+px, (y/2)*2+py);
	}
      else
	{
	  for (px=x; px<x+pointer*2-1; px+=2)
	    for (py=y; py<y+pointer*2-1; py+=2)
	      if (RANGE_IMAGE(px,py) &&
		  BLACKSEARCH(px,py)==0)
		DATASEARCH(px,py)=colorhelp[DATASEARCH(px,py)].darker;
	  for (px=0; px<pointer*2+1; px++)
	    for (py=0; py<pointer*2+1; py++)
	      if ((x/2)*2+px<640 && (y/2)*2+py<400)
		es_pixel((x/2)*2+px,(y/2)*2+py);
	}
    }
}



void main(int argc, char **argv)
{
  int x,y,z,X,Y,Z,tx,ty;
  long size;
  char s[200];
  
  printf("Editskin %s %d - Sampo Savolainen (ethernal@pcuf.fi)\n",VERSION,YEAR);
  if (argc!=2 && argc!=3) { fprintf(stderr,"usage: %s filename <maskfile>\n",argv[0]); exit(1); }
  
  x=open(argv[1],O_RDONLY);
  if (x==-1) { perror(argv[1]); exit(1); }
  close(x);
  
  init_helps();
  
  if (es_hasmode()==0)
    {
      fprintf(stderr,"Sorry, your hardware doesn't support %s\n",es_getmodename());
      exit(1);
    }
  
  es_init();
  
  sprintf(s,"%s/.%s",getenv("HOME"),CONFIGURATION_FILE);
  read_conf(s);
  
  if (argc==2)
    pcx=read_pcx(conf_maskfile);
  else
    pcx=read_pcx(argv[2]);
  
  mask_sX=pcx.xmax-pcx.xmin+1;
  mask_sY=pcx.ymax-pcx.ymin+1;
  
  size=(long)(pcx.xmax-pcx.xmin+1)*(long)(pcx.ymax-pcx.ymin+1);
  black=(char *) malloc(size);
  memset(black,0,size);
  for (x=0; x<size; x++) if (data[x]==0) black[x]=1;
  
  pcx=read_pcx(argv[1]);
  
  pcx_sizex=pcx.xmax-pcx.xmin+1;
  pcx_sizey=pcx.ymax-pcx.ymin+1;
  
  if (pcx_sizex>mask_sX || pcx_sizey>mask_sY)
    {
      fprintf(stderr,"error: mask file is smaller than the data file, aborting...\n");
      exit(1);
    }
  
  quit=invert=invert_mask=copy=0;
  t_pinfo=1;
  pointer=6;
  s_color=15;
  
  for (x=0; x<640; x++)
    for (y=0; y<480; y++)
      es_pixel(x,y);
  
  while (quit==0)
    {
      if (ev.ox!=ev.mx || ev.oy!=ev.my)
	{
	  if ( (RANGE_PINFO(ev.ox,ev.oy)) || 
	       (RANGE_PINFO(ev.ox+mouse_sizex,ev.oy+mouse_sizey)) ) 
	    t_pinfo=1;
	  erase_cursor(ev.ox,ev.oy);
	  draw_cursor(ev.mx,ev.my,C_WHITE);
	  ev.ox=ev.mx; ev.oy=ev.my;
	}
      
      if ( es_checkbutton(ev.mb)==ES_LEFTBUTTON) m_button(ev.mx,ev.my);
      
      ev=es_handler(ev);
      
      if (ev.key>0)
	{
	  x=s_color; z=pointer; Y=rounded;
	  
	  if (ev.key==key_brush_enlarge)
	    {
	      if (pointer<19) pointer+=2; 
	    } else
	      if (ev.key==key_brush_shrink)
		{
		  if (pointer>01) pointer-=2;
		} else
		  if (ev.key==key_brush_brighten)
		    {
		      s_color=colorhelp[x].brighter;
		    } else
		      if (ev.key==key_brush_darken)
			{
			  s_color=colorhelp[x].darker;
			} else
			  if (ev.key==key_copy_set)
			    {
			      if (copy==0)
				{
				  copy=1; bx=ev.mx; by=ev.my;
				  pinfo(EMPTYSTRING);
				  pinfo("Copy start");
				} else
				  if (copy==1)
				    {
				      erase_cursor(ev.mx,ev.my);
				      if (bx<ev.mx) { cx[0]=bx; cx[1]=ev.mx; } else
					{ cx[0]=ev.mx; cx[1]=bx; }
				      if (by<ev.my) { cy[0]=by; cy[1]=ev.my; } else
					{ cy[0]=ev.my; cy[1]=by; }
				      for (tx=cx[0]; tx<cx[1]+1; tx+=2)
					for (ty=cy[0]; ty<cy[1]+1; ty+=2)
					  COPYSEARCH(((tx-cx[0])/2),((ty-cy[0])/2))=DATASEARCH(tx,ty);
				      copy=2;
				      pinfo(EMPTYSTRING);
				      pinfo("Copy end");
				      draw_cursor(ev.mx,ev.my,C_PALETTE(s_color));
				    } else
				      if (copy==2)
					{
					  erase_cursor(ev.mx,ev.my);
					  copy=0;
					  pinfo(EMPTYSTRING);
					  pinfo("Copy clear");
					}
			    } else
			      if (ev.key==key_copy_draw)
				{
				  if (copy==2);
				  {
				    for (tx=-2; tx<(cx[1]-cx[0])+2; tx++)
				      for (ty=-2; ty<(cy[1]-cy[0])+2; ty++)
					if ((tx+ev.mx)<pcx_sizex*2 && (ty+ev.my)<pcx_sizey*2 &&
					    (tx+ev.mx)>-1 && (ty+ev.my)>-1                     )
					  if (BLACKSEARCH((tx+ev.mx),(ty+ev.my))==0)
					    {
					      if (tx>-1 && tx<(cx[1]-cx[0]) &&
						  ty>-1 && ty<(cy[1]-cy[0])   )
						DATASEARCH((tx+ev.mx),(ty+ev.my))=COPYSEARCH((tx/2),(ty/2));
					      es_pixel(tx+ev.mx,ty+ev.my);
					    }
				  }
				} else
				  if (ev.key==key_draw_brighter)
				    {
				      m_brighten(ev.mx,ev.my);
				    } else
				      if (ev.key==key_draw_darker)
					{
					  m_darken(ev.mx,ev.my);
					} else
					  if (ev.key==key_show_realcolor)
					    {
					      if (showrealc==0) showrealc=1; else showrealc=0;
					      for (tx=0; tx<WIDTH; tx++)
						for (ty=0; ty<400; ty++)
						  es_pixel(tx,ty);
					      draw_cursor(ev.mx,ev.my,C_PALETTE(s_color));
					    } else
					      if (ev.key==key_brush_round)
						{
						  if (rounded==1)
						    rounded=0;
						  else
						    rounded=1;
						} else
						  if (ev.key==key_mask_invert)
						    {
						      if (invert_mask==0)
							invert_mask=-1;
						      else
							invert_mask=0;
						    } else
						      if (ev.key==key_brush_c_next)
							{
							  if (s_color<255) s_color++;
							} else
							  if (ev.key==key_brush_c_prev)
							    {
							      if (s_color>0)   s_color--;
							    } else
							      if (ev.key==key_cursor_invert)
								{
								  erase_cursor(ev.mx,ev.my);
								  if (invert==0) invert=1; else invert=0;
								  draw_cursor(ev.mx,ev.my,C_PALETTE(s_color));
								} else
								  if (ev.key==key_quit) quit=1; else
								    if (ev.key==key_save) savebox(pcx); 
	  
	  if (rounded==1 && pointer<2) pointer=2;
	  if (Y!=rounded)
	    {
	      for (x=600; x<WIDTH; x++)
		for (y=440; y<HEIGHT; y++) 
		  es_pixel(x,y);
	    }
	  
	  if (x!=s_color) 
	    {
	      pinfo(EMPTYSTRING);
	      pinfo(colorhelp[s_color].name);
	      draw_cursor(ev.mx,ev.my,C_WHITE);
	      for (x=600; x<WIDTH; x++)
		for (y=440; y<HEIGHT; y++)
		  es_pixel(x,y);
	    }
	  
	  if (z!=pointer || Y!=rounded)
	    {
	      Z=rounded; rounded=Y;
	      X=pointer; pointer=z;
	      erase_cursor(ev.mx,ev.my);
	      pointer=X; rounded=Z;
	      draw_cursor(ev.mx,ev.my,C_WHITE);
	      for (x=POINTERSIZE_PX; x<POINTERSIZE_PX+39; x++)
		for (y=POINTERSIZE_PY; y<POINTERSIZE_PY+39; y++)
		  es_pixel(x,y);
	    }
	  
	}
    }
  
  es_close();
  
  free(data);
  free(palette);
}
